// Pavel Zolnikov[http://www.codeproject.com/script/profile/whos_who.asp?id=35980], 2002

using System;
using System.Reflection;
using System.Runtime.InteropServices;

namespace BandObjects
{
	/// <summary>
	/// Represents different styles of a band object.
	/// </summary>
	[Flags]
	[Serializable]
	[ComVisible(false)]
	public enum BandObjectStyles : int
	{
		Vertical		= 1,
		Horizontal		= 2,
		ExplorerToolbar = 4,
		TaskbarToolBar	= 8
	}
	
	/// <summary>
	/// Specifies Style of the band object, its Name(displayed in explorer menu) and HelpText(displayed in status bar when menu command selected).
	/// </summary>
	[ComVisible(false)]
	[AttributeUsage(AttributeTargets.Class)]
	public sealed class BandObjectAttribute : System.Attribute
	{
		public BandObjectAttribute(){}

		public BandObjectAttribute(string name, BandObjectStyles style)
		{
			Name = name;
			Style = style;
		}
		public BandObjectStyles Style;
		public string Name;
		public string HelpText;
	}
}