// Pavel Zolnikov[http://www.codeproject.com/script/profile/whos_who.asp?id=35980], 2002

using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace BandObjects
{
	public abstract class ExplorerGUIDs
	{
		public static readonly Guid IID_IWebBrowserApp = new Guid("{0002DF05-0000-0000-C000-000000000046}");
		public static readonly Guid IID_IUnknown =		 new Guid("{00000000-0000-0000-C000-000000000046}");
	}

	[Flags]
	public enum DBIM
	{
		MINSIZE   =0x0001,
		MAXSIZE   =0x0002,
		INTEGRAL  =0x0004,
		ACTUAL    =0x0008,
		TITLE     =0x0010,
		MODEFLAGS =0x0020,
		BKCOLOR   =0x0040
	}

	[Flags]
	public enum DBIMF
	{
		DBIMF_NORMAL           =0x0000,
		DBIMF_FIXED            =0x0001,
		DBIMF_FIXEDBMP         =0x0004,
		DBIMF_VARIABLEHEIGHT   =0x0008,
		DBIMF_UNDELETEABLE     =0x0010,
		DBIMF_DEBOSSED         =0x0020,
		DBIMF_BKCOLOR          =0x0040,
		DBIMF_USECHEVRON       =0x0080,
		DBIMF_BREAK            =0x0100,
		DBIMF_ADDTOFRONT       =0x0200,
		DBIMF_TOPALIGN         =0x0400
	}


	[StructLayout(LayoutKind.Sequential,CharSet=CharSet.Unicode)]
	public struct DESKBANDINFO
	{
		public DBIM			dwMask;
		public Point	    ptMinSize;
		public Point		ptMaxSize;
		public Point		ptIntegral;
		public Point		ptActual;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst=255)]
		public String		wszTitle;
		public DBIMF		dwModeFlags;
		public Int32		crBkgnd;
	};

	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("FC4801A3-2BA9-11CF-A229-00AA003D7352")] 
	public interface IObjectWithSite
	{
		void SetSite([In ,MarshalAs(UnmanagedType.IUnknown)] Object site);
		void GetSite(ref Guid riid, [MarshalAs(UnmanagedType.IUnknown)] out Object site);
	}

	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("00000114-0000-0000-C000-000000000046")] 
	public interface IOleWindow
	{
		void GetWindow(out System.IntPtr hwnd);   
		void ContextSensitiveHelp([In] bool enterMode);
	}

	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("012dd920-7b26-11d0-8ca9-00a0c92dbfe8")] 
	public interface IDockingWindow
	{
		void GetWindow(out System.IntPtr hwnd);   
		void ContextSensitiveHelp([In] bool enterMode);

		void ShowDW([In] bool show);
		void CloseDW([In] Int32  reserved);
		void ResizeBorderDW(
			IntPtr borderRectangle,
			[In, MarshalAs(UnmanagedType.IUnknown)] Object toolbarSite,
			bool reserved);
	}


	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("EB0FE172-1A3A-11D0-89B3-00A0C90A90AC")] 
	public interface IDeskBand
	{
		void GetWindow(out System.IntPtr hwnd);   
		void ContextSensitiveHelp([In] bool enterMode);

		void ShowDW([In] bool show);
		void CloseDW([In] Int32  reserved);
		
		void ResizeBorderDW(
			IntPtr borderRectangle,
			[In, MarshalAs(UnmanagedType.IUnknown)] Object toolbarSite,
			bool reserved);

		void GetBandInfo(
			Int32 bandID,
			Int32 viewMode,
			ref DESKBANDINFO info);
	}


	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("0000010c-0000-0000-C000-000000000046")]
	public interface IPersist
	{
		void GetClassID(out Guid classID);
	}

	
	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("00000109-0000-0000-C000-000000000046")]
	public interface IPersistStream
	{
		void GetClassID(out Guid classID);

		void IsDirty ();

		void Load ([In, MarshalAs(UnmanagedType.Interface)] Object stream);

		void Save ([In, MarshalAs(UnmanagedType.Interface)] Object stream,
			[In] bool clearDirty);

		void GetSizeMax ([Out] out Int64 size);
	}


	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("6d5140c1-7436-11ce-8034-00aa006009fa")]
	public interface IServiceProviderCOM
	{
		void QueryService(
			ref Guid guid, 
			ref Guid riid, 
			[MarshalAs(UnmanagedType.Interface)] out Object obj);
	}


	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("68284faa-6a48-11d0-8c78-00c04fd918b4")]
	public interface IInputObject
	{
		void UIActivateIO(Int32 activate, ref MSG  msg);
		
		[PreserveSig]
		Int32 HasFocusIO();

		[PreserveSig]
		Int32 TranslateAcceleratorIO(ref MSG msg);
	}

	[ComImport]
	[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
	[Guid("f1db8392-7331-11d0-8c99-00a0c92dbfe8")]
	public interface IInputObjectSite
	{
		[PreserveSig]
		Int32 OnFocusChangeIS( [MarshalAs(UnmanagedType.IUnknown)] Object obj, Int32 setFocus);
	}

	public struct POINT
	{
		public Int32		x;
		public Int32		y;
	}

	public struct MSG 
	{
		public IntPtr		hwnd;
		public Int32		message;
		public Int32		wParam;
		public Int32		lParam;
		public Int32		time;
		public POINT		pt;
	}
}